# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::Hdinsight::Mgmt::V2015_03_01_preview
  module Models
    #
    # The execution details of a script action.
    #
    class RuntimeScriptActionDetail < RuntimeScriptAction

      include MsRestAzure

      # @return [Integer] The execution id of the script action.
      attr_accessor :script_execution_id

      # @return [String] The start time of script action execution.
      attr_accessor :start_time

      # @return [String] The end time of script action execution.
      attr_accessor :end_time

      # @return [String] The current execution status of the script action.
      attr_accessor :status

      # @return [String] The reason why the script action was executed.
      attr_accessor :operation

      # @return [Array<ScriptActionExecutionSummary>] The summary of script
      # action execution result.
      attr_accessor :execution_summary

      # @return [String] The script action execution debug information.
      attr_accessor :debug_information


      #
      # Mapper for RuntimeScriptActionDetail class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RuntimeScriptActionDetail',
          type: {
            name: 'Composite',
            class_name: 'RuntimeScriptActionDetail',
            model_properties: {
              name: {
                client_side_validation: true,
                required: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              uri: {
                client_side_validation: true,
                required: true,
                serialized_name: 'uri',
                type: {
                  name: 'String'
                }
              },
              parameters: {
                client_side_validation: true,
                required: false,
                serialized_name: 'parameters',
                type: {
                  name: 'String'
                }
              },
              roles: {
                client_side_validation: true,
                required: true,
                serialized_name: 'roles',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              application_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'applicationName',
                type: {
                  name: 'String'
                }
              },
              script_execution_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'scriptExecutionId',
                type: {
                  name: 'Number'
                }
              },
              start_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'startTime',
                type: {
                  name: 'String'
                }
              },
              end_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'endTime',
                type: {
                  name: 'String'
                }
              },
              status: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'status',
                type: {
                  name: 'String'
                }
              },
              operation: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'operation',
                type: {
                  name: 'String'
                }
              },
              execution_summary: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'executionSummary',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'ScriptActionExecutionSummaryElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'ScriptActionExecutionSummary'
                      }
                  }
                }
              },
              debug_information: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'debugInformation',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
